#
# spec file for package mx4j
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           mx4j
Version:        3.0.2
Release:        lp150.3.21
Summary:        Open Source Implementation of JMX Java API
License:        Apache-2.0
Group:          Development/Libraries/Java
Url:            http://mx4j.sourceforge.net/
Source0:        mx4j-%{version}-src.tar.bz2
Source1:        mx4j-build.policy
Source2:        CatalogManager.properties
Patch0:         mx4j-javaxssl.patch
Patch2:         mx4j-build.patch
Patch3:         mx4j-docbook.patch
Patch5:         mx4j-caucho-build.patch
Patch7:         mx4j-3.0.2-docbook-stylesheet-location.patch
Patch8:         mx4j-3.0.2-sourcetarget.patch
BuildRequires:  ant
BuildRequires:  ant-junit
BuildRequires:  antlr
BuildRequires:  apache-commons-logging
BuildRequires:  axis
BuildRequires:  bcel
BuildRequires:  docbook-xsl-stylesheets
BuildRequires:  docbook_3
BuildRequires:  jaf
BuildRequires:  java-devel >= 1.6.0
BuildRequires:  javamail
BuildRequires:  javapackages-tools
BuildRequires:  junit
BuildRequires:  libtool
BuildRequires:  log4j-mini
BuildRequires:  perl
BuildRequires:  servletapi5
BuildRequires:  unzip
BuildRequires:  update-alternatives
BuildRequires:  xalan-j2
BuildRequires:  xerces-j2
Requires:       apache-commons-logging >= 1.0.1
Requires:       axis >= 1.1
Requires:       bcel >= 5.0
Requires:       jaf
Requires:       javamail >= 1.2-5jpp
Requires:       jce >= 1.2.2
Requires:       log4j >= 1.2.7
Requires:       xml-commons
Requires:       xml-commons-apis
Requires:       xml-commons-resolver
Requires(post): update-alternatives
Requires(postun): update-alternatives
Obsoletes:      openjmx < %{version}
Provides:       jmx
Provides:       jmxri
Provides:       openjmx = %{version}
BuildArch:      noarch

%description
OpenJMX is an open source implementation of the Java(TM) Management
Extensions (JMX).

%prep
%setup -q
%patch0 -p1
%patch2 -p1
%patch3 -p1
%patch5 -p1
%patch7 -p1
%patch8 -p1
cp %{SOURCE1} build
cp %{SOURCE2} build
pushd lib
   ln -sf $(build-classpath junit) .
   ln -sf $(build-classpath xml-commons-apis) xml-apis.jar                || :
   ln -sf $(build-classpath xerces-j2) xercesImpl.jar                     || :
   ln -sf $(build-classpath xalan-j2) xalan.jar                           || :
   ln -sf $(build-classpath xalan-j2-serializer)                          || :
   ln -sf $(build-classpath commons-logging)                              || :
   ln -sf $(build-classpath log4j)                                        || :
   ln -sf $(build-classpath bcel)                                         || :
   ln -sf $(build-classpath axis/axis)                                    || :
   ln -sf $(build-classpath axis/jaxrpc)                                  || :
   ln -sf $(build-classpath axis/saaj)                                    || :
   ln -sf $(build-classpath wsdl4j)                                       || :
   ln -sf $(build-classpath commons-discovery)                            || :
   ln -sf $(build-classpath servletapi5) servlet.jar                      || :
   ln -sf $(build-classpath jython)                                       || :
   ln -sf $(build-classpath jaas)                                         || :
popd

%build
export GC_MAXIMUM_HEAP_SIZE="134217728" #128M
ln -sf $(build-classpath gnumail) lib/mail.jar
ln -sf $(build-classpath activation) lib/
export ANT_OPTS="-Djava.security.manager \
                 -Djava.security.policy=$(pwd)/build/mx4j-build.policy \
                 -Dant.build.javac.source=1.6 \
                 -Dant.build.javac.target=1.6"
export OPT_JAR_LIST="ant/ant-junit junit ant/ant-trax jaxp_transform_impl"
export CLASSPATH=$(build-classpath glibj-tools activation javamail/mailapi javamail/smtp \
   jetty4 jython jakarta-commons-logging xml-commons-apis bcel jaas jce \
   log4j jaxp_transform_impl axis/axis axis/jaxrpc axis/saaj \
   xml-commons-resolver xdoclet/xdoclet xdoclet/xdoclet-jmx-module \
   xdoclet/xdoclet-mx4j-module xalan-j2-serializer)
export CLASSPATH=${CLASSPATH}:%{_builddir}/%{name}-%{version}/classes/core:%{_builddir}/%{name}-%{version}/build
cd build
ant compile.jmx compile.rjmx compile.tools compile.examples

%install
install -d -m 755 %{buildroot}%{_javadir}/%{name}
install -d -m 755 %{buildroot}%{_datadir}/%{name}
install -m 644 dist/lib/%{name}-impl.jar %{buildroot}%{_javadir}/%{name}/%{name}-impl-%{version}.jar
install -m 644 dist/lib/%{name}-jmx.jar %{buildroot}%{_javadir}/%{name}/%{name}-jmx-%{version}.jar
install -m 644 dist/lib/%{name}.jar %{buildroot}%{_javadir}/%{name}/%{name}-%{version}.jar
install -m 644 dist/lib/%{name}-tools.jar %{buildroot}%{_javadir}/%{name}/%{name}-tools-%{version}.jar
install -m 644 dist/lib/%{name}-rjmx.jar %{buildroot}%{_javadir}/%{name}/%{name}-rjmx-%{version}.jar
install -m 644 dist/lib/%{name}-rimpl.jar %{buildroot}%{_javadir}/%{name}/%{name}-rimpl-%{version}.jar
install -m 644 dist/lib/%{name}-remote.jar %{buildroot}%{_javadir}/%{name}/%{name}-remote-%{version}.jar
install -d -m 755 %{buildroot}%{_javadir}/%{name}/boa
install -m 644 dist/lib/boa/%{name}-rjmx-boa.jar %{buildroot}%{_javadir}/%{name}/boa/%{name}-rjmx-boa-%{version}.jar
install -m 644 dist/lib/boa/%{name}-rimpl-boa.jar %{buildroot}%{_javadir}/%{name}/boa/%{name}-rimpl-boa-%{version}.jar
install -m 644 dist/lib/boa/%{name}-remote-boa.jar %{buildroot}%{_javadir}/%{name}/boa/%{name}-remote-boa-%{version}.jar
pushd %{buildroot}%{_javadir}/%{name}
   for jar in *-%{version}.jar ; do
      ln -fs ${jar} $(echo $jar | sed "s|-%{version}.jar|.jar|g")
   done
popd
# alternatives
mkdir -p %{buildroot}%{_sysconfdir}/alternatives/
ln -sf %{_sysconfdir}/alternatives/jmxri.jar %{buildroot}%{_javadir}/jmxri.jar

%post
%{_sbindir}/update-alternatives --install %{_javadir}/jmxri.jar jmxri %{_javadir}/%{name}/%{name}-jmx.jar 0

%postun
if [ "$1" = "0" ]; then
	%{_sbindir}/update-alternatives --remove jmxri %{_javadir}/%{name}/%{name}-jmx.jar
fi

%files
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%dir %{_javadir}/%{name}/boa
%{_javadir}/%{name}/boa/*.jar
%{_javadir}/jmxri.jar
%ghost %{_sysconfdir}/alternatives/jmxri.jar

%changelog
* Thu Oct  5 2017 fstrba@suse.com
- Fix build with jdk9
  * specify java source and target level 1.6
- Added patch:
  * mx4j-3.0.2-sourcetarget.patch
    + Don't hardcode java source and target levels
    + Allow specifying of source and target levels on command-line
- Modified file:
  * mx4j-build.policy
    + grant java.lang.RuntimePermission in order to allow building
    with jdk9
* Tue Sep 12 2017 fstrba@suse.com
- BuildConflict with java-devel >= 1.9, since this package cannot
  be built with jdk9
- Removed patch:
  * mx4j-3.0.2-use-external-rmic.patch
    + building with JDK's rmic work
* Fri May 19 2017 tchvatal@suse.com
- Drop dependency over jython, not needed
- Remove unused conditional
* Mon Jul 21 2014 tchvatal@suse.com
- Cleanup with spec-cleaner and fixup update-alternatives code
* Tue Jul  8 2014 tchvatal@suse.com
- Do not depend on ant-trax.
* Fri Jun 27 2014 tchvatal@suse.com
- Add jython as explicit dep.
* Fri Jun 27 2014 tchvatal@suse.com
- Sort out loggings dep to proceed bit further in SLE11 build
* Mon Sep  9 2013 tchvatal@suse.com
- Move from jpackage-utils to javapackage-tools
* Fri Aug 23 2013 mvyskocil@suse.com
- disable javadoc and manual packages
* Tue Jun 26 2012 mvyskocil@suse.cz
- use java-devel >= 1.6.0 to build after jdk6 drop
* Mon Sep 19 2011 mvyskocil@suse.cz
- add openjdk do buildrequires allowing a build again
* Mon Nov 23 2009 mvyskocil@suse.cz
- Removed external JSSE implementation - see bnc#557168
* Thu Nov 19 2009 mvyskocil@suse.cz
- Update to 3.0.2 - a bugfix release fixes:
  - JMX monitors
  - JMX remote connector over IIOP
  - registration/deregistration of JMX listeners.
- Refreshed patches to apply without a fuzz
* Tue Jul 15 2008 coolo@suse.de
- next try to reduce build cycles
* Wed Apr  9 2008 mvyskocil@suse.cz
- fixed a build with gjc_1_5_0-compat
- removed some rpmlint warnings:
  - bzipped source code
  - add update-alternatives to PreReq
  - remove the unecessary docbook-style patch
- remove the xmlunit.tar
* Tue May  8 2007 dbornkessel@suse.de
- provide jmx
* Wed May  2 2007 dbornkessel@suse.de
- added unzip to BuildRequires
* Fri Jan 12 2007 dbornkessel@suse.de
- major update to version 3.0.1
  1.1.1 -> 3.0.1
  - JMXServerErrorException thrown during setAttribute invoc.
  - Class loading problem at RMIConnectorServer.start()
  - Basic authentication fails
  - Fetcher thread in RemoteNotificationClientHandler never ends
  - Null pointer exception accessing attribute in model bean
  - RelationService: possible method call param sequence error
  - JMXConnectorServer binding names rather than rebinding JNDI
  - MBeanServer.queryMBeans/Names not thread safe
  - GaugeMonitor setThresholds wrong error message
  - NotifBroadcasterSupport.sendNotif not thread safe
  - MBean registration notification emitted too soon
  - NullPointerException with MLets with no name attribute
  - NotificationListener when server shutdown
  - NotificationBroadcasterSupport error/failed remote listener
  - InvokerMBeanServerInterceptor uses Class.forName
  - bug in ssl http adapter example class
  - Timer MBean should not be daemon
  - MBeanServer.getAttributes() does not follow spec.
  - j.m.monitor.Monitor is not abstract
  - Error in loading the dll using Mlet classloader
  - Invalid value returned for SpecificationVersion
  - MBeanAttributeInfo.equals() ignores description
  - Invalid escape in ObjectName not caught
  - ModelMBeanInfoSupport copy constructor is not complete
  - DescriptorSupport doesn't provide a useful clone imp.
  - Caching Support In Required Model MBean Is Broken
  - JDK 1.3 + MX4J 2.0.1 examples/remote/simple
  - Wrong use of Properties in IIOPResolver class
  - NoSuchMethodError - class file inconsistency
  - Signature compliance for javax.management package
  - Client notification queue overflow
  - Busy Loop on SOAPConnectorServer fetching Notifications
  - XSL problem in serverbydomain.xsl
  - HttpAdapter example code should have public MBeanInterface
  - MLet files should be read with UTF-8 encoding
  - Permissions at start() vs permissions during invocation
  - JMXRI + MX4J documentation is wrong
  - Documentation is wrong
  - Do not write to System.out
  - ModelMBeanInfoSupport#getDescriptors("mbean") does not work
  - RMIConnectorServer problem
  - RequiredModelMBean methods are not invoked !!!
  - DescriptorSupport does not preserve case
  - HttpAdaptor doesn't stop cleanly
  - XSLTProcessor stylesheet error
  - Cannot use port 80 for SOAPConnector
  - Issue in ModelMBeanConstructorInfo descriptor checking
  - Invoke setManagedResource on RequiredModelMBean
  - MBeanDescription not working
  - TabularType hashCode value computed incorrectly
  - MBeanAttributeInfo validation of methods too restrictive
  - System.loadLibrary() is replacing dll with empty file
  - RelationService
  - Race condition in Tomcat 5
  - MBean interface required in same package as implementor
  - CounterMonitor behaves strangely on rollover
  - Add support to discover providers under META-INF/services
  - Add easier SSL protocol for JMXConnectorServers
  - NotificationListener wrapping
  - Default domain is "DefaultDomain"
  - Between operation only operates on numerics
  - Timer must increment seq number
  - An MBean can be in multiple relations
  - setRoles returns wrong value; NPE in getRoles
  - Should throw NoSuchMethodEx if Relation is not implemented
  - RelationSupport roleList can be null
  - findRelationsOfType must throw RelationTypeNotFoundException
  - removeRelationType should throw RelationTypeNotFoundExceptio
  - addRelationType should fail with invalid args
  - Duplicate RelationType should throw InvalidRelationType
  - MBS.isInstanceOf needs to check assignability
  - Exception in preDeregister should terminate immediately
  - Exception from preRegister prevents registration
  - addNotificationListener observed ObjectName cannot be null
  - Notification status should be cleared when monitor stops
  - CounterMonitor should not notify if already able threshold
  - CounterMonitor value can be negative
  - MBeanPermission 4-arg form, null is same as "-"
  - RequiredModelMBean must list default notifications
  - RequiredModelMBean should have one notification broadcaster
  - Incompatible JSR160 implementations between mx4j & sun
  - Several issues with DescriptorSupport
  - In MBeanPersmission, empty [] is allowed
  - Attempt to create an abstract MBean throws wrong exception
  - Incorrect handling of <arg type="object">
  - ModelMBean resource type is case insensitive
  - MBeanPermission implies is incorrect with wildcards
  - MBeanServerPermission must reject invalid names
  - ObjectName should reject unterminated strings
  - ReflectionExceptions are not wrapped
  - MBeanInfo missing classname is not compliant
  - Incorrect default objectname for MLet
  - java.util.ConcurrentModificationException
  - XSLTprocessor produce bad input names
  - Array of primitive types are not correctly displayed
  - Formatting error in "xsl/mbean_attributes.xsl"
  - error in "xsl/mbean_attributes.xsl"
  - Make MX4J JDK 1.5 friendly
  - Timing hole in Monitor stop() start() processing
  - ModelMBeanInfoSupport.getDescriptor(name, type) returns null
  - Could not re-add listener when MBean is unregistered
  - Memory leaks in notification interceptor
  - OutOfMemoryError in Java 1.5 on Refresh
  - RMIConnector cannot unmarshal custom Notifications
  - Monitor thread remains alive when monitors are stopped
  - JettyWebContainer shouldn't listen on localhost
  - please revert the -poa change
  - RMI-IIOP example broken
  - ConcurrentModificationException in DefaultMBeanRepository
  - IIOP / ORB.init
* Mon Sep 25 2006 dbornkessel@suse.de
- set source=\"1.4\" and target=\"1.4\" for ant \"javac\" tasks"
  - set source=\"1.4\" for ant \"javadoc\" tasks"
  - fix Java 1.5 code ambiguity (cf. bsc#4983021)"
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Wed Dec 14 2005 dbornkessel@suse.de
- uncommented the dynamic security provider loading as those providers
  are configures statically for each JRE / SDK.
- replaced deprecated log4j statements with their newer equivalents
* Wed Sep 28 2005 dmueller@suse.de
- add norootforbuild
* Thu Sep 16 2004 skh@suse.de
- Fix prerequires
* Sun Sep  5 2004 skh@suse.de
- Initial package created with version 1.1.1 (JPackage 1.5)
